<template>
  <div class="main-contain">
    <div class="position">
      <!--<bread-crumb :crumbs='crumbs'></bread-crumb>-->
      <bread-crumb :crumbs="crumbs"></bread-crumb>
      <el-button
        size="small"
        @click="handleWarehouse"
        class="filter-item"
        style="float:right;"
        type="primary"
        icon="el-icon-circle-plus-outline"
        >新增</el-button
      >
    </div>

    <div class="app-container">
      <div class="cell clearfix">
        <el-input
          size="small"
          style="width: 400px;"
          v-model.trim="searchKey"
          class="filter-item"
          placeholder="单据编码/制单人/厂商"
        />
        <el-button
          size="small"
          class="filter-item"
          type="primary"
          icon="el-icon-search"
          @click="search"
          >搜索</el-button
        >
      </div>

      <div class="cell clearfix">
        <label class="title"><span class="name">入库时间</span> : </label>
        <el-date-picker
          size="small"
          v-model="start_time"
          prefix-icon="el-icon-date"
          :editable="false"
          style="width: 196px;"
          type="date"
          placeholder="选择日期时间"
          align="right"
          format="yyyy-MM-dd"
          value-format="yyyy-MM-dd"
          @change="startTimeChange"
        ></el-date-picker>
        <span class="cellLine"> - </span>
        <el-date-picker
          size="small"
          v-model="end_time"
          prefix-icon="el-icon-date"
          :editable="false"
          style="width: 196px;"
          type="date"
          placeholder="选择日期时间"
          align="right"
          format="yyyy-MM-dd"
          value-format="yyyy-MM-dd"
          @change="endTimeChange"
        ></el-date-picker>
      </div>

      <div class="cell clearfix">
        <el-checkbox
          style="width: 70px"
          v-model="checked"
          @change="changeAllSelected"
          >全选</el-checkbox
        >
        <el-button size="small" icon="el-icon-delete" @click="batchDelete"
          >删除</el-button
        >
      </div>

      <el-table
        :data="Warehouse.warehouseDate"
        :class="signAndWeighBoxPatients"
        style="width: 100%"
        border
        highlight-current-row
        v-loading="Warehouse.loading"
        ref="multipleTable"
        @selection-change="select"
        :row-style="{ color: '#303133' }"
        :header-cell-style="{
          backgroundColor: 'rgb(245, 247, 250)',
          color: '#606266'
        }"
      >
        <el-table-column align="center" type="selection" width="55">
        </el-table-column>

        <el-table-column label="单据日期" align="center">
          <template slot-scope="scope">
            {{ scope.row.warehousing_time | parseTime("{y}-{m}-{d}") }}
          </template>
        </el-table-column>

        <el-table-column label="单据编号" align="center">
          <template slot-scope="scope">
            {{ scope.row.warehousing_order }}
          </template>
        </el-table-column>

        <el-table-column label="制单人" align="center">
          <template slot-scope="scope">
            {{ getXuserName(scope.row.creater) }}
          </template>
        </el-table-column>

        <el-table-column label="厂家" align="center">
          <template slot-scope="scope">
            {{ getManufactuerName(scope.row.manufacturer) }}
          </template>
        </el-table-column>

        <el-table-column label="经销商" align="center">
          <template slot-scope="scope">
            {{ getDealerName(scope.row.dealer) }}
          </template>
        </el-table-column>

        <el-table-column label="操作" align="center" width="260px">
          <template slot-scope="scope">
            <el-tooltip
              class="item"
              effect="dark"
              content="详情"
              placement="top"
            >
              <el-button
                size="small"
                type="warning"
                icon="el-icon-document"
                @click="handleSearch(scope.row.id)"
              >
              </el-button>
            </el-tooltip>
            <el-tooltip
              class="item"
              effect="dark"
              content="编辑"
              placement="top"
            >
              <el-button
                size="small"
                type="primary"
                icon="el-icon-edit-outline"
                @click="handleEdit(scope.$index, scope.row)"
              >
              </el-button>
            </el-tooltip>

            <el-tooltip
              class="item"
              effect="dark"
              content="删除"
              placement="top"
            >
              <el-button
                size="small"
                type="danger"
                icon="el-icon-delete"
                @click="handleDelete(scope.$index, scope.row)"
              >
              </el-button>
            </el-tooltip>
          </template>
        </el-table-column>
      </el-table>

      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :page-sizes="[10, 50, 100]"
        :page-size="10"
        background
        style="margin-top:20px;float: right"
        layout="total, sizes, prev, pager, next, jumper"
        :total="total"
      >
      </el-pagination>
    </div>



    <el-dialog
      title="详情"
      :visible.sync="dialogVisible"
      width="80%"
     >
      <span>
        <div>
          <el-row>
           <span style="font-size: 18px;color: #606266">入库单详情</span>
          </el-row>
            <el-row style="float:left;">
            <span style="color: #606266"
              >入库单号: {{ WarehouseInfo.warehouse.warehousing_order }}</span
            >
          </el-row>
        </div>
         <div class="cell clearfix">
          <span style="width: 300px;color: #606266;float:right">单据日期:{{ WarehouseInfo.warehouse.warehousing_time | parseTime("{y}-{m}-{d}")}} </span>
          <span style="width: 300px;color: #606266;float:right">厂商:{{ getManufactuerName(WarehouseInfo.warehouse.manufacturer) }}</span>
          <span style="width: 300px;color: #606266"
            >经销商:{{ getDealerName(WarehouseInfo.warehouse.dealer) }} </span>
       </div>
        <div class="cell clearfix" style="margin-top: 10px">
          <el-button size="small" icon="el-icon-edit" @click="editRecord"
            >编辑</el-button
          >
          <el-button size="small" icon="el-icon-delete" @click="deleteRecord"
            >删除</el-button
          >

      <el-row :gutter="12" style="margin-top: 10px">
        <el-table
          :data="WarehouseInfo.warehouseInfoDate"
          :class="signAndWeighBoxPatients"
          style="width: 100%"
          border
          :header-cell-style="{ backgroundColor: 'rgb(245, 247, 250)' }"
        >
          <el-table-column min-width="35" align="center">
            <template slot="header" slot-scope="scope">
              <span>耗材类型</span>
            </template>

            <template slot-scope="scope">
              <span v-if="scope.row.good_type_id != 0">{{
                getTypeName(scope.row.good_type_id)
              }}</span>
            </template>
          </el-table-column>
          <el-table-column min-width="35" align="center">
            <template slot="header" slot-scope="scope">
              <span>耗材名称</span>
            </template>

            <template slot-scope="scope">
              <span v-if="scope.row.good_id != 0">{{
                getTypeNameOne(scope.row.good_id)
              }}</span>
            </template>
          </el-table-column>
          <el-table-column min-width="35" align="center">
            <template slot="header" slot-scope="scope">
              <span>规格型号</span>
            </template>
            <template slot-scope="scope">
              <span v-if="scope.row.good_id != 0">{{
                getSpecificationName(scope.row.good_id)
              }}</span>
            </template>
          </el-table-column>

          <el-table-column min-width="23" align="center">
            <template slot="header" slot-scope="scope">
              <span>进货价</span>
            </template>
            <template slot-scope="scope">
              <span>{{ scope.row.price }}</span>
            </template>
          </el-table-column>

          <el-table-column min-width="23" align="center">
            <template slot="header" slot-scope="scope">
              <span>入库数量</span>
            </template>
            <template slot-scope="scope">
              <span>{{ scope.row.warehousing_count }}</span>
            </template>
          </el-table-column>

          <el-table-column label="总价" min-width="20" align="center">
            <template slot-scope="scope">
              {{ calculate(scope.row.price * scope.row.warehousing_count) }}
            </template>
          </el-table-column>

          <el-table-column align="center" min-width="25">
            <template slot="header" slot-scope="scope">
              <span>批号</span>
            </template>
            <template slot-scope="scope">
              <span>{{ scope.row.number }}</span>
            </template>
          </el-table-column>
          <el-table-column label="生产日期" min-width="40" align="center">
            <template v-if="scope.row.product_date != 0" slot-scope="scope">
              {{ scope.row.product_date }}
            </template>
          </el-table-column>
          <el-table-column label="有效日期" min-width="40" align="center">
            <template v-if="scope.row.expiry_date != 0" slot-scope="scope">
              {{ scope.row.expiry_date  }}
            </template>
          </el-table-column>
          <el-table-column label="备注" min-width="20" align="center">
            <template slot-scope="scope">
              <el-popover placement="top-start" width="250" trigger="hover">
                <div>{{ scope.row.remark }}</div>
                <span slot="reference" v-if="scope.row.remark.length > 20">{{
                  scope.row.remark.substr(0, 20) + "..."
                }}</span>
                <span slot="reference" v-else>{{ scope.row.remark }}</span>
              </el-popover>
            </template>
          </el-table-column>
        </el-table>
      </el-row>
      </div>

      </span>
      <span slot="footer" class="dialog-footer">
        <el-button @click="dialogVisible = false">取 消</el-button>
        <el-button type="primary" @click="dialogVisible = false">确 定</el-button>
      </span>
    </el-dialog>


    <el-dialog
      title="新增"
      :visible.sync="editDialogVisible"
      width="80%"
    >
      <span>
       
        <div style="margin-bottom:10px">
          <label class="title"><span class="name">入库时间</span> : </label>
          <el-date-picker size="small" v-model="warehousing_time" prefix-icon="el-icon-date" :editable="false"
                          style="width: 196px;" type="date" placeholder="选择日期时间" align="right" format="yyyy-MM-dd"
                          value-format="yyyy-MM-dd"></el-date-picker>
          <label class="title" style="margin-left:10px;"><span class="name">经 销 商</span> : </label>
          <el-select size="small" v-model="form.dealer" clearable placeholder="请选择经销商" @change="changeDealer">
            <el-option
              v-for="(option, index) in dealer"
              :key="index"
              :label="option.dealer_name"
              :value="option.id">
            </el-option>
          </el-select>
          <label class="title" style="margin-left:10px;"><span class="name">厂商</span> : </label>

          <el-select size="small" v-model="form.manufacturer" clearable placeholder="请选择厂商" @change="changeManufacturer">
            <el-option
              v-for="(option, index) in manufacturer"
              :key="index"
              :label="option.manufacturer_name"
              :value="option.id">
            </el-option>
          </el-select>
        </div>

        <el-form :rules="tableRules" :model="recordInfo" ref="tableForm">
        <el-table
          id="oictable"
          :data="recordInfo.recordData"
          :class="signAndWeighBoxPatients"
          style="width: 100%"
          border
          max-height="450"
          :header-cell-style="{ backgroundColor: 'rgb(245, 247, 250)' }"
        >
          <el-table-column align="center" width="200">
            <template slot="header" slot-scope="scope">
              <span>商品类型<span style="color: red">*</span></span>
            </template>

            <template slot-scope="scope">
              <el-form-item style="padding-top: 15px">
                <el-input
                  placeholder="请输入商品类型"
                  v-model="scope.row.good_type_id"
                  :value="typeName(scope.row.good_type_id)"
                  @focus="showDialog(scope.$index, scope.row)"
                ></el-input>
              </el-form-item>
            </template>
          </el-table-column>
          <el-table-column align="center" width="200">
            <template slot="header" slot-scope="scope">
              <span>规格名称<span style="color: red">*</span></span>
            </template>
            <template slot-scope="scope">
              <el-form-item style="padding-top: 15px">
                <el-input
                  placeholder="请输入规格名称"
                  v-model="scope.row.good_id"
                  :value="specificationName(scope.row.good_id)"
                  @focus="showDialog(scope.$index, scope.row)"
                ></el-input>
              </el-form-item>
            </template>
          </el-table-column>

          <el-table-column align="center" width="150">
            <template slot="header" slot-scope="scope">
              <span>单价<span style="color: red">*</span></span>
            </template>
            <template slot-scope="scope">
              <!--<el-input type="number" v-model="scope.row.price"  @blur="handleBlur(scope.$index, scope.row)"></el-input>-->
              <el-form-item
                :prop="'recordData.' + scope.$index + '.price'"
                :rules="tableRules.price"
                style="padding-top: 17px"
              >
                <el-input
                  placeholder="请输入单价"
                  type="number"
                  v-model="scope.row.price"
                ></el-input>
              </el-form-item>
            </template>
          </el-table-column>

          <el-table-column align="center" width="180">
            <template slot="header" slot-scope="scope">
              <span>入库数量<span style="color: red">*</span></span>
            </template>
            <template slot-scope="scope">
              <!--{{scope.row.warehousing_count}}-->
              <!--<el-input type="number" v-model="scope.row.warehousing_count"   @blur="handleBlur(scope.$index, scope.row)"></el-input>-->

              <el-form-item
                :prop="'recordData.' + scope.$index + '.warehousing_count'"
                :rules="tableRules.warehousing_count"
                style="padding-top: 17px"
              >
                <el-input
                  placeholder="请输入入库数量"
                  type="number"
                  v-model="scope.row.warehousing_count"
                ></el-input>
              </el-form-item>
            </template>
          </el-table-column>
          <el-table-column label="总价" align="center" width="150">
            <template slot-scope="scope">
              {{ calculate(scope.row.price * scope.row.warehousing_count) }}
            </template>
          </el-table-column>

          <el-table-column align="center" width="150">
            <template slot="header" slot-scope="scope">
              <span>批号</span>
            </template>
            <template slot-scope="scope">
              <el-form-item style="padding-top: 15px">
                <el-input
                  placeholder="请输入批号"
                  v-model="scope.row.number"
                ></el-input>
              </el-form-item>
            </template>
          </el-table-column>

          <el-table-column label="生产日期" width="250" align="center">
            <template slot-scope="scope">
            
              <el-date-picker
                prefix-icon="el-icon-date"
                style="width: 145px"
                v-model="scope.row.product_date"
                type="date"
                placeholder="选择日期时间"
                format="yyyy-MM-dd"
                value-format="yyyy-MM-dd"
              ></el-date-picker>
            </template>
          </el-table-column>
          <el-table-column label="有效日期" width="250" align="center">
            <template slot-scope="scope">
             
              <el-date-picker
                prefix-icon="el-icon-date"
                style="width: 145px"
                v-model="scope.row.expiry_date"
                type="date"
                placeholder="选择日期时间"
                format="yyyy-MM-dd"
                value-format="yyyy-MM-dd"
              ></el-date-picker>
            </template>
          </el-table-column>
          <el-table-column label="备注" width="150" align="center">
            <template slot-scope="scope">
              <el-input v-model="scope.row.remark"></el-input>
            </template>
          </el-table-column>

          <el-table-column
            label="操作"
            fixed="right"
            align="center"
            width="150"
          >
            <template slot-scope="scope">
              <el-tooltip
                class="item"
                effect="dark"
                content="新增"
                placement="top"
              >
                <el-button
                  size="mini"
                  type="primary"
                  icon="el-icon-circle-plus-outline"
                  @click="handleEditTwo(scope.$index, scope.row)"
                >
                </el-button>
              </el-tooltip>
              <el-tooltip
                class="item"
                effect="dark"
                content="删除"
                placement="top"
              >
                <el-button
                  size="mini"
                  type="danger"
                  icon="el-icon-delete"
                  @click="DeleteWarehouseInfoItem(scope.$index, scope.row)"
                >
                </el-button>
              </el-tooltip>
            </template>
          </el-table-column>
        </el-table>
      </el-form>
      </span>
      <span slot="footer" class="dialog-footer">
        <el-button @click="editDialogVisible = false">取 消</el-button>
        <el-button type="primary" @click="submit()">保 存</el-button>
      </span>
    </el-dialog>


     <stock-in-dialog
        ref="dialog"
        :propForm="propForm"
        :visibility="isVisibility"
        v-on:dialog-comfirm="comfirm"
        v-on:dialog-cancle="cancle">
    </stock-in-dialog>
  </div>
</template>

<script>
import stockInDialog from "./Dialog/stockInDialog";
import { uParseTime } from "@/utils/tools";
import { fetchAllAdminUsers, fetchAllDoctorAndNurse } from "@/api/doctor";
import {
  deleteWarehouseInfo,
  GetAllConfig,
  GetAllGoodInfo,
  GetAllGoodType,
  getWarehouseInfoList,
  getWarehouseList,
  DeleteWarehouseInfoItem,
  GetAllGoodInfoByID,
  EditWarehouse
} from "@/api/stock";

import { GetAllDrugInfoByID,postDrugWarehouse} from "@/api/drug/drug_stock";
import BreadCrumb from "../components/bread-crumb";

export default {
  name: "stockIn",
  components: { BreadCrumb, stockInDialog },
  created() {

    var nowDate = new Date();
    var nowYear = nowDate.getFullYear();
    var nowMonth = nowDate.getMonth() + 1;
    var nowDay = nowDate.getDate();
    this.end_time =
      nowYear +
      "-" +
      (nowMonth < 10 ? "0" + nowMonth : nowMonth) +
      "-" +
      (nowDay < 10 ? "0" + nowDay : nowDay);
    nowDate.setMonth(nowDate.getMonth() - 1);
    nowMonth = nowDate.getMonth() + 1;
    nowDay = nowDate.getDate();
    this.start_time =
      nowYear +
      "-" +
      (nowMonth < 10 ? "0" + nowMonth : nowMonth) +
      "-" +
      (nowDay < 10 ? "0" + nowDay : nowDay);
     
     

      // this.warehousing_time =
      //   nowYear +
      //   '-' +
      //   (nowMonth < 10 ? '0' + nowMonth : nowMonth) +
      //   '-' +
      //   (nowDay < 10 ? '0' + nowDay : nowDay)

    
    this.GetWarehouse();
    this.GetConfigInfo();
    this.fetchAllAdminUsers();
    this.GetAllGoodType()
    this.GetAllGoodInfo()
  },
  data() {

    var checkGoodId = (rule, value, callback) => {
      setTimeout(() => {
        if (value == "" || value == 0) {
          return callback(new Error("规格名称不能为空"));
        }
      }, 2000);
    };
    return {
      crumbs: [
        { path: false, name: "库存管理" },
        { path: false, name: "入库单" }
      ],
      searchKey: "",
      type: 1,
      page: 1,
      limit: 10,
      checked: false,
      total: 0,
      pageTotal: 0,
      pageSelect: 0,
      adminUserOptions: [],
      multipleSelection: [],
      signAndWeighBoxPatients: "sign-and-weigh-box-patients",
      start_time: "",
      end_time: "",
      goodType: [],
      goodInfo: [],
      manufacturer: [],
      selectedTableData: [],
      dealer: [],
      Warehouse: {
        loading: false,
        warehouseDate: [],
        tableCurrentIndex: ""
      },

      WarehouseInfo: {
        loading: false,
        warehouseInfoDate: [],
        warehouse: {}
      },
      startTime: "",
      dialogVisible:false,
      editDialogVisible:false,

      recordInfo: {
        recordData: [],
        stock_in_code: "",
        current_index: ""
      },

      tableRules: {
        price: [{ required: true, message: "单价不能为空", trigger: "blur" }],
        warehousing_count: [
          { required: true, message: "数量不能为空", trigge: "blur" }
        ],

        good_id: [{ validator: checkGoodId, trigger: "blur" }]
      },

      form: {
        manufacturer:0,
        dealer:0
      }, 
      warehousing_time: '',
     warehouse:{},
      propForm: {
        goods: [],
        goodType: [],
        goodInfo: [],
        goodUnit: [],
        title: '入库',
        formValue: {
        good_type_id: '',
        good_id: '',
        number: '',
        product_date: '',
        expiry_date: '',
        warehousing_count: '',
        price: '',
        remark: '',
        dealer: '',
        manufacturer: ''
      },
        isCreated: 1,
        isVisibility: false,
        drug_id:1
      },
    };

  
  },
  methods: {
    search: function() {
      const Params = {
        page: this.page,
        limit: this.limit,
        start_time: this.start_time,
        end_time: this.end_time,
        type: this.type,
        keywords: this.searchKey
      };
      this.Warehouse.warehouseDate = [];
      getWarehouseList(Params).then(response => {
        if (response.data.state == 0) {
          this.Warehouse.loading = false;
          this.$message.error(response.data.msg);
          return false;
        } else {
          this.Warehouse.loading = false;
          this.total = response.data.data.total;
          for (let i = 0; i < response.data.data.list.length; i++) {
            this.Warehouse.warehouseDate.push(response.data.data.list[i]);
          }
        }
      });
    },
    GetWarehouse: function() {
      const Params = {
        page: this.page,
        limit: this.limit,
        start_time: this.start_time,
        end_time: this.end_time,
        type: this.type
      };
      this.Warehouse.warehouseDate = [];
      getWarehouseList(Params).then(response => {
        if (response.data.state == 0) {
          this.Warehouse.loading = false;
          this.$message.error(response.data.msg);
          return false;
        } else {
          this.Warehouse.loading = false;
          this.total = response.data.data.total;
          for (let i = 0; i < response.data.data.list.length; i++) {
            this.Warehouse.warehouseDate.push(response.data.data.list[i]);
          }
        }
      });
    },
    tableRowClassName({ row, rowIndex }) {
      // 把每一行的索引放进row
      row.index = rowIndex;
    },
    onRowClick(row, event, column) {
      this.WarehouseInfo.warehouseInfoDate = [];
      this.Warehouse.tableCurrentIndex = row.index;
      const params = {
        id: row.id
      };
      this.WarehouseInfo.loading = true;
      getWarehouseInfoList(params).then(response => {
        if (response.data.state == 0) {
          this.WarehouseInfo.loading = false;
          this.$message.error(response.data.msg);
          return false;
        } else {
          this.WarehouseInfo.loading = false;
          for (let i = 0; i < response.data.data.info.length; i++) {
            this.WarehouseInfo.warehouseInfoDate.push(response.data.data.info[i]);
          }
        }
      });
    },
    getXuserName(id) {
      if (id <= 0) {
        return "";
      }
      var name = "";
      if (
        this.adminUserOptions == null ||
        typeof this.adminUserOptions.length === "undefined"
      ) {
        return name;
      }
      var leng = this.adminUserOptions.length;
      if (leng == 0) {
        return name;
      }
      for (let index = 0; index < leng; index++) {
        if (this.adminUserOptions[index].id == id) {
          name = this.adminUserOptions[index].name;
          break;
        }
      }
      return name;
    },
    fetchAllDoctorAndNurse() {
      fetchAllDoctorAndNurse().then(response => {
        if (response.data.state == 1) {
          this.doctorOptions = response.data.data.doctors;
        }
      });
    },
    fetchAllAdminUsers() {
      fetchAllAdminUsers().then(response => {
        console.log(response);
        if (response.data.state == 1) {
          this.adminUserOptions = response.data.data.users;
          var alen = this.adminUserOptions.length;
          for (let index = 0; index < alen; index++) {
            if (this.adminUserOptions[index].user_type == 2) {
              // this.doctorOptions.push(this.adminUserOptions[index]);
            }
          }
        }
      });
    },
    getSpecificationName: function(id) {
      let name = "";
      for (let i = 0; i < this.goodInfo.length; i++) {
        if (this.goodInfo[i].id == id) {
          name = this.goodInfo[i].specification_name;
        }
      }

      return name;
    },
    getTypeName: function(id) {
      let name = "";
      for (let i = 0; i < this.goodType.length; i++) {
        if (this.goodType[i].id == id) {
          name = this.goodType[i].type_name;
        }
      }
      return name;
    },
    getTypeNameOne:function(id){
      console.log("999999",this.goodInfo)
     
      let name = "";
      for (let i = 0; i < this.goodInfo.length; i++) {
        if (this.goodInfo[i].id == id) {
          name = this.goodInfo[i].good_name;
        }
      }
      return name;
    },
    GetAllGoodType: function() {
      GetAllGoodType().then(response => {
        if (response.data.state == 0) {
          this.$message.error(response.data.msg);
          return false;
        } else {
          
          for (let i = 0; i < response.data.data.goodType.length; i++) {
            this.goodType.push(response.data.data.goodType[i]);
          }
        }
      });
    },
    GetAllGoodInfo: function() {
      GetAllGoodInfo().then(response => {
        if (response.data.state == 0) {
          this.$message.error(response.data.msg);
          return false;
        } else {
          
          for (let i = 0; i < response.data.data.goodInfo.length; i++) {

            this.goodInfo.push(response.data.data.goodInfo[i]);
          }
        }
      });
    },
    clicks: function() {
      console.log(this.WarehouseInfo.warehouseInfoDate);
    },
    handleWarehouse: function() {
      this.$router.push({ path: "/stock/in/add", query: { type: this.type } });
    },
    handleReturnSales: function() {
      // this.$router.push({path:'/patients/create'}
      if (this.multipleSelection.length <= 0) {
        this.$message.error("请选择退货商品");
        return;
      }

      const ids = [];
      for (let i = 0; i < this.multipleSelection.length; i++) {
        ids.push(this.multipleSelection[i].id);
      }
      this.$router.push({ name: "salesReturn", query: { id: ids.join("&") } });
    },
    handleReturnSalesRecord: function() {
      this.$router.push({ name: "salesReutrnRecord" });
    },
    handleWarehouseRecord: function() {
      this.$router.push({ name: "warehouseRecord" });
    },
    handleSelectionChange: function(val) {
      this.multipleSelection = val;
    },
    handleSizeChange(val) {
      this.limit = val;
      this.GetWarehouse();
    },
    handleCurrentChange(val) {
      this.page = val;
      this.GetWarehouse();
    },
    startTimeChange(val) {
      var time = this.getTimestamp(val) - this.getTimestamp(this.end_time);
      if (time > 0) {
        this.$message.error("结束时间不能小于开始时间");
        this.start_time = "";
      } else {
        this.startTime = this.getTimestamp(val);
        this.GetWarehouse();
      }
    },
    endTimeChange(val) {
      var time = this.getTimestamp(val) - this.getTimestamp(this.start_time);
      if (time < 0) {
        this.$message.error("结束时间不能小于开始时间");
        this.end_time = "";
      } else {
        this.GetWarehouse();
      }
    },
    getTimestamp(time) {
      // 把时间日期转成时间戳
      return new Date(time).getTime() / 1000;
    },
    getTime(val, temp) {
      if (val != 0) {
        return uParseTime(val, temp);
      } else {
        return "";
      }
    },
    calculate: function(val) {
      return Math.round(parseFloat(val) * 100) / 100;
    },
    GetConfigInfo: function() {
      GetAllConfig().then(response => {
        if (response.data.state == 0) {
          this.$message.error(response.data.msg);
          return false;
        } else {
          this.manufacturer = response.data.data.manufacturer;
          this.dealer = response.data.data.dealer;
          this.manufacturer.splice(0, 0, { id: 0, manufacturer_name: "全部" });
          this.dealer.splice(0, 0, { id: 0, dealer_name: "全部" });
         
        }
      });
    },
    getManufactuerName: function(manufacturer_id) {
      for (let i = 0; i < this.manufacturer.length; i++) {
        if (this.manufacturer[i].id == manufacturer_id) {
          return this.manufacturer[i].manufacturer_name;
        }
      }
    },
    getDealerName: function(dealer_id) {
      for (let i = 0; i < this.dealer.length; i++) {
        if (this.dealer[i].id == dealer_id) {
          return this.dealer[i].dealer_name;
        }
      }
    },
    handleEdit: function(index, row) {
      this.$router.push({
        name: "stockInDetail",
        query: { id: row.id, type: this.type }
      });
    },
    handleDelete: function(index, row) {
      const ids = [];
      ids.push(row.id);
      const idStr = ids.join(",");

      const params = {
        ids: idStr
      };
     
      this.$confirm("确认删除入库单记录?", "删除入库单记录", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
        .then(() => {
          deleteWarehouseInfo(params).then(response => {
            if (response.data.state == 0) {
              this.$message.error(response.data.msg);
              return false;
            } else {
              this.$notify({
                title: "成功",
                message: "删除成功",
                type: "success",
                duration: 2000
              });
              for (let i = 0; i < ids.length; i++) {
                for (let y = 0; y < this.Warehouse.warehouseDate.length; y++) {
                  if (ids[i] == this.Warehouse.warehouseDate[y].id) {
                    this.Warehouse.warehouseDate.splice(y, 1);
                  }
                }
              }
            }
          });
        })
        .catch(() => {});
    },
    changeAllSelected: function(val) {
      if (val) {
        this.$refs.multipleTable.toggleAllSelection();
      } else {
        this.$refs.multipleTable.clearSelection();
      }
    },
    select(selection) {
      this.selectedTableData = selection;
    },
    batchDelete() {
      if (this.selectedTableData.length <= 0) {
        this.$message.error("请选择要删除的记录");
        return;
      }
      const ids = [];
      for (let i = 0; i < this.selectedTableData.length; i++) {
        ids.push(this.selectedTableData[i].id);
      }
      const idStr = ids.join(",");
      const params = {
        ids: idStr
      };
      this.$confirm("确认删除入库单记录?", "删除入库单记录", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
        .then(() => {
          deleteWarehouseInfo(params).then(response => {
            if (response.data.state == 0) {
              this.$message.error(response.data.msg);
              return false;
            } else {
              this.$notify({
                title: "成功",
                message: "删除成功",
                type: "success",
                duration: 2000
              });

              for (let i = 0; i < ids.length; i++) {
                for (let y = 0; y < this.Warehouse.warehouseDate.length; y++) {
                  if (ids[i] == this.Warehouse.warehouseDate[y].id) {
                    this.Warehouse.warehouseDate.splice(y, 1);
                  }
                }
              }
            }
          });
        })
        .catch(() => {});
    },

    handleSearch(id){
      this.GetOrderDetail(id)
      this.drug_id = id
      this.dialogVisible = true
    },

    GetOrderDetail: function(id) {
      const params = {
        id: id
      };
      getWarehouseInfoList(params).then(response => {
        if (response.data.state == 0) {
          this.$message.error(response.data.msg);
          return false;
        } else {
          console.log("2223333-------",response.data.data.info)
          for (let i = 0; i < response.data.data.info.length; i++) {
            this.WarehouseInfo.warehouseInfoDate.push(response.data.data.info[i]);
            response.data.data.info[i].product_date = this.getTime(
              response.data.data.info[i].product_date,
              "{y}-{m}-{d}"
            );
            response.data.data.info[i].expiry_date = this.getTime(
              response.data.data.info[i].expiry_date,
              "{y}-{m}-{d}"
            );
            
           response.data.data.info[i].price = response.data.data.info[i].price.toString();
           response.data.data.info[i].warehousing_count = response.data.data.info[i].warehousing_count.toString();

            this.recordInfo.recordData.push(response.data.data.info[i]);

          
          }
           this.warehouse = response.data.data.warehousing;
           this.warehousing_time = this.getTime(this.warehouse.warehousing_time,"{y}-{m}-{d}");
           console.log("单据日期",this.warehousing_time)
          this.WarehouseInfo.warehouse = response.data.data.warehousing;
         
        }
      });
    },

     editRecord: function() {
     
     
      this.editDialogVisible = true
    },

     deleteRecord: function() {
      const ids = [];
      ids.push(this.WarehouseInfo.warehouse.id);
      const idStr = ids.join(",");

      const params = {
        ids: idStr
      };

      this.$confirm("确认删除入库单记录?", "删除入库单记录", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
        .then(() => {
          deleteWarehouseInfo(params).then(response => {
            if (response.data.state == 0) {
              this.$message.error(response.data.msg);
              return false;
            } else {
              this.$notify({
                title: "成功",
                message: "删除成功",
                type: "success",
                duration: 2000
              });

              this.$router.back(-1);
            }
          });
        })
        .catch(() => {});
    },

     typeName: function(good_type_id) {
     
      let name = "";
      for (let i = 0; i < this.goodType.length; i++) {
        if (this.goodType[i].id == good_type_id) {
          name = this.goodType[i].type_name;
        }
      }
      return name;
    },

    showDialog(index, row) {
      this.currentIndex = index;
      const params = {
        manufacturer_id: this.form.manufacturer,
        dealer_id: this.form.dealer
      };
      this.propForm.goods = []

      GetAllGoodInfoByID(params).then(response => {
        if (response.data.state == 0) {
          this.$message.error(response.data.msg);
          return false;
        } else {
          if (response.data.data.goodInfo.length <= 0) {
            this.$message.error("该厂商或经销商没有物品信息");
            return;
          }
          this.$refs.dialog.show();
          for (let i = 0; i < response.data.data.goodInfo.length; i++) {
            this.propForm.goodType.push(
              response.data.data.goodInfo[i].type
            );
          }
          const obj = {};
          this.propForm.goodType = this.propForm.goodType.reduce(
            (cur, next) => {
              obj[next.id] ? "" : (obj[next.id] = true && cur.push(next));
              return cur;
            },
            []
          ); // 设置cur默认类型为数组，并且初始值为空的数组
        }

        for (let i = 0; i < this.propForm.goodType.length; i++) {
          let goodInfo = [];
          let goodObj = {};

          for (let a = 0; a < response.data.data.goodInfo.length; a++) {
            var respObj = response.data.data.goodInfo[a];
            respObj["isSelected"] = false;
            if (respObj.type.id == this.propForm.goodType[i].id) {
              goodInfo.push(respObj);
            }
          }
          const obj = {};
          goodInfo = goodInfo.reduce((cur, next) => {
            obj[next.id] ? "" : (obj[next.id] = true && cur.push(next));
            return cur;
          }, []); // 设置cur默认类型为数组，并且初始值为空的数组

          this.$set(goodObj, this.propForm.goodType[i].id, goodInfo);
          this.propForm.goods.push(goodObj);
        }
      });
    },

    specificationName: function(drug_id) {
     
        let name = "";
        for (let i = 0; i < this.goodInfo.length; i++) {
          if (this.goodInfo[i].id == drug_id) {
            name = this.goodInfo[i].specification_name;
          }
        }
        return name;
    }, 

     submit() {
      this.$refs["tableForm"].validate(valid => {
        if (valid) {
          const array = this.recordInfo.recordData;
          console.log('array',array)
          for (let i = 0; i < array.length; i++) {
            if (array[i].good_type_id == 0) {
              this.$message.error("商品类型不能为空");
              return;
            }
            if (array[i].good_id == 0) {
              this.$message.error("规格名称不能为空");
              return;
            }
          }

          const params = {
            stockIn: this.recordInfo.recordData
          };
          EditWarehouse(
            params,
            this.warehousing_time,
            this.drug_id,
            this.type,
            this.form.manufacturer,
            this.form.dealer
          ).then(response => {
            if (response.data.state == 0) {
              this.$message.error(response.data.msg);
              return false;
            } else {
              this.$message.success("入库成功");
              this.dialogVisible = false
              this.editDialogVisible = false
             
            }
          });
        } else {
          return false;
        }
      });
    },

      changeManufacturer(val) {

      }, 
      changeDealer(val) {

      },

     DeleteWarehouseInfoItem: function(index, row) {
      if (row.id == 0) {
        this.recordInfo.recordData.splice(index, 1);
      } else {
        const params = {
          id: row.id
        };
        this.$confirm("确认删除该入库商品信息记录?", "删除入库商品信息记录", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            DeleteWarehouseInfoItem(params).then(response => {
              if (response.data.state == 0) {
                this.$message.error(response.data.msg);
                return false;
              } else {
                this.$message.success("删除成功");

                this.recordInfo.recordData.splice(index, 1);
              }
            });
          })
          .catch(() => {});
      }
    },
    handleEditTwo: function(index, row) {
      const tempObj = {};
      tempObj["id"] = 0;
      tempObj["good_type_id"] = 0;
      tempObj["good_id"] = 0;
      tempObj["number"] = "";
      tempObj["product_date"] = "";
      tempObj["expiry_date"] = "";
      tempObj["warehousing_count"] = "";
      tempObj["price"] = "";
      tempObj["remark"] = "";
      tempObj["dealer"] = "";
      tempObj["manufacturer"] = "";
      this.recordInfo.recordData.push(tempObj);
    },

     comfirm: function(val) {
      this.$refs.dialog.hide();
      this.propForm.goodType = [];
      this.propForm.goods = [];

      if (val.selectedGoodInfo.length > 0) {
        for (let i = val.selectedGoodInfo.length - 1; ; i--) {
          if (i == 0) {
            this.recordInfo.recordData[this.currentIndex].good_type_id =
              val.selectedGoodInfo[i].good_type_id;
            this.recordInfo.recordData[this.currentIndex].good_id =
              val.selectedGoodInfo[i].id;
            this.recordInfo.recordData[
              this.currentIndex
            ].price = val.selectedGoodInfo[i].buy_price.toString();
          } else {
            const tempForm = {};
            tempForm["id"] = 0;
            tempForm["good_type_id"] = val.selectedGoodInfo[i].good_type_id;
            tempForm["good_id"] = val.selectedGoodInfo[i].id;
            tempForm["number"] = "";
            tempForm["product_date"] = "";
            tempForm["expiry_date"] = "";
            tempForm["warehousing_count"] = "";
            tempForm["price"] = val.selectedGoodInfo[i].buy_price.toString();
            tempForm["remark"] = "";
            tempForm["dealer"] = "";
            tempForm["manufacturer"] = "";
            this.recordInfo.recordData.splice(
              this.currentIndex + 1,
              0,
              tempForm
            );
          }
        }
      }

      this.currentIndex = -1;
    },
    cancle: function() {
      this.$refs.dialog.hide();
      this.propForm.goods = [];

      this.propForm.goodType = [];
    },
  }
};
</script>

<style rel="stylesheet/css" lang="scss" scoped>
.information {
  border: 1px #dcdfe6 solid;
  padding: 30px 20px 30px 20px;

  .border {
    border-bottom: 1px #dcdfe6 solid;
    margin: 0px 0 20px 0;
  }
}

.edit_separater {
  border-top: 1px solid rgb(233, 233, 233);
  margin-top: 15px;
  margin-bottom: 15px;
}
</style>

<style>
.sign-and-weigh-box .sign-and-weigh-box-patients .cell {
  font-size: 12px;
}

.sign-and-weigh-box .sign-and-weigh-box-patients .current-row > td {
  background: #6fb5fa;
}

.count {
  color: #bd2c00;
}
.el-table td,
.el-table th.is-leaf,
.el-table--border,
.el-table--group {
  border-color: #d0d3da;
}
.el-table--border::after,
.el-table--group::after,
.el-table::before {
  background-color: #d0d3da;
}
</style>
